---
title: Picture-in-Picture API
slug: Web/API/Picture-in-Picture_API
tags:
  - API
  - DOM
  - Graphics
  - Guide
  - Overview
  - Picture-in-Picture
  - Picture-in-Picture API
  - Reference
  - Video
  - View
  - pip
---
<div>{{DefaultAPISidebar("Picture-in-Picture API")}}</div>

<p>The <strong>Picture-in-Picture API</strong> allow websites to create a floating video window always on top of other windows so that users may continue consuming media while they interact with other content sites, or applications on their device.</p>

<h2 id="Interfaces">Interfaces</h2>

<dl>
 <dt>{{DOMxRef("PictureInPictureWindow")}}</dt>
 <dd>Represents the floating video window; contains {{domxref("PictureInPictureWindow/width", "width")}} and {{domxref("PictureInPictureWindow/height", "height")}} properties, and an {{domxref("PictureInPictureWindow/onresize", "onresize")}} event handler property.</dd>
</dl>

<h2 id="Methods">Methods</h2>

<p>The Picture-in-Picture API adds methods to the {{DOMxRef("HTMLVideoElement")}} and {{DOMxRef("Document")}} interfaces to allow toggling of the floating video window.</p>

<h3 id="Methods_on_the_HTMLVideoElement_interface">Methods on the HTMLVideoElement interface</h3>

<dl>
 <dt>{{DOMxRef("HTMLVideoElement.requestPictureInPicture()")}}</dt>
 <dd>Requests that the user agent enters the video into picture-in-picture mode</dd>
</dl>

<dl>
 <dt>
 <h3 id="Methods_on_the_Document_interface">Methods on the Document interface</h3>
 </dt>
 <dt>{{DOMxRef("Document.exitPictureInPicture()")}}</dt>
 <dd>Requests that the user agent returns the element in picture-in-picture mode back into its original box.</dd>
</dl>

<h2 id="Properties">Properties</h2>

<p><em>The Picture-in-Picture API augments the </em>{{DOMxRef("HTMLVideoElement")}}, {{DOMxRef("Document")}}, and {{DOMxRef("DocumentOrShadowRoot")}} <em> interfaces with properties that can be used to determine if the floating video window mode is supported and available, if picture-in-picture mode is currently active, and which video is floating.</em></p>

<h3 id="Properties_on_the_HTMLVideoElement_interface">Properties on the HTMLVideoElement interface</h3>

<dl>
 <dt>{{DOMxRef("HTMLVideoElement.autoPictureInPicture")}}</dt>
 <dd>The <code>autoPictureInPicture</code> property will automatically enter and leave the picture-in-picture mode for a video element when the user switches tab and/or applications.</dd>
 <dt>{{DOMxRef("HTMLVideoElement.disablePictureInPicture")}}</dt>
 <dd>The <code>disablePictureInPicture</code> property will provide a hint to the user agent to not suggest the picture-in-picture to users or to request it automatically.</dd>
</dl>

<dl>
 <dt>
 <h3 id="Properties_on_the_Document_interface">Properties on the Document interface</h3>
 </dt>
 <dt>{{DOMxRef("Document.pictureInPictureEnabled")}}</dt>
 <dd>The <code>pictureInPictureEnabled</code> property tells you whether or not it is possible to engage picture-in-picture mode. This is <code>false</code> if picture-in-picture mode is not available for any reason (e.g. the <a href="/en-US/docs/Web/HTTP/Headers/Feature-Policy/picture-in-picture"><code>"picture-in-picture"</code> feature</a> has been disallowed, or picture-in-picture mode is not supported).</dd>
</dl>

<h3 id="Properties_on_the_DocumentOrShadowRoot_interface">Properties on the DocumentOrShadowRoot interface</h3>

<dl>
 <dt>{{DOMxRef("DocumentOrShadowRoot.pictureInPictureElement")}}</dt>
 <dd>The <code>pictureInPictureElement</code> property tells you which {{DOMxRef("Element")}} is currently being displayed in the floating window. If this is <code>null</code>, the document has no node currently in picture-in-picture mode.</dd>
</dl>

<h2 id="Events">Events</h2>

<p><em>The Picture-in-Picture API defines three events, which can be used to detect when picture-in-picture mode is toggled and when the floating video window is resized.</em></p>

<dl>
 <dt>{{domxref("HTMLVideoElement.enterpictureinpicture_event", "enterpictureinpicture")}}</dt>
 <dd>Sent to a {{DOMxRef("HTMLVideoElement")}} when it enters picture-in-picture mode. The associated event handler is {{DOMxRef("HTMLVideoElement.onenterpictureinpicture")}}</dd>
 <dt>{{domxref("HTMLVideoElement.leavepictureinpicture_event", "leavepictureinpicture")}}</dt>
 <dd>Sent to a {{DOMxRef("HTMLVideoElement")}} when it leaves picture-in-picture mode. The associated event handler is {{DOMxRef("HTMLVideoElement.onleavepictureinpicture")}}</dd>
 <dt>{{domxref("PictureInPictureWindow.resize_event", "resize")}}</dt>
 <dd>Sent to a {{DOMxRef("PictureInPictureWindow")}} when it changes size. The associated event handler is {{DOMxRef("PictureInPictureWindow.onresize")}}</dd>
</dl>

<h2 id="Controlling_styling">Controlling styling</h2>

<p>The <code><a href="/en-US/docs/Web/CSS/:picture-in-picture">:picture-in-picture</a></code> <a href="/en-US/docs/Web/CSS">CSS</a> <a href="/en-US/docs/Web/CSS/Pseudo-classes">pseudo-class</a> matches the video element currently in picture-in-picture mode, allowing you to configure your stylesheets to automatically adjust the size, style, or layout of content when a video switches back and forth between picture-in-picture and traditional presentation modes.</p>

<h2 id="Controlling_access">Controlling access</h2>

<p>The availability of picture-in-picture mode can be controlled using <a href="/en-US/docs/Web/HTTP/Feature_Policy">Feature Policy</a>. The full-screen mode feature is identified by the string <code>"picture-in-picture"</code>, with a default allow-list value of <code>"self"</code>, meaning that picture-in-picture mode is permitted in top-level document contexts, as well as to nested browsing contexts loaded from the same origin as the top-most document.</p>

<p>See <a href="/en-US/docs/Web/HTTP/Feature_Policy/Using_Feature_Policy">Using Feature Policy</a> to learn more about using Feature Policy to control access to an API.</p>

<h2 id="Examples">Examples</h2>

<p>In this example, a video is presented in a web page. Clicking the button below lets the user toggle the floating video window.</p>

<p>{{EmbedGHLiveSample("dom-examples/picture-in-picture/index.html", '100%', 350)}}</p>

<h3 id="Toggling_full-screen_mode">Toggling full-screen mode</h3>

<p>This code is called by a click handler when the user clicks the "<span class="pl-s">Toggle Picture-in-Picture</span>" button:</p>

<pre class="brush: js notranslate">function togglePictureInPicture() {
  if (document.pictureInPictureElement) {
      document.exitPictureInPicture();
  } else {
    if (document.pictureInPictureEnabled) {
      video.requestPictureInPicture();
    }
  }
}</pre>

<p>This block starts by looking at the value of the {{DOMxRef("Document", "document")}}'s <code>pictureInPictureElement</code> attribute. If the value is <code>null</code>, no video is in the floating window. so we can request a video to enter the picture-in-picture mode; otherwise, it's the element that's currently in picture-in-picture mode. Switching to picture-in-picture mode is done by calling {{DOMxRef("HTMLVideoElement.requestPictureInPicture()")}} on the {{HTMLElement("video")}} element.</p>

<p>If a video is in the floating window (<code>pictureInPictureElement</code> is not <code>null</code>), we call {{DOMxRef("Document.exitPictureInPicture", "exitPictureInPicture()")}} on the <code>document</code> to bring the video back into its initial box.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName("Picture-in-Picture")}}</td>
   <td>{{Spec2("Picture-in-Picture")}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<h3 id="HTMLVideoElement.requestPictureInPicture"><code>HTMLVideoElement.requestPictureInPicture</code></h3>

<p>{{Compat("api.HTMLVideoElement.requestPictureInPicture")}}</p>

<h3 id="HTMLVideoElement.autoPictureInPicture"><code>HTMLVideoElement.autoPictureInPicture</code></h3>

<div class="hidden">The compatibility table on this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</div>

<p>{{Compat("api.HTMLVideoElement.autoPictureInPicture")}}</p>

<h3 id="HTMLVideoElement.disablePictureInPicture"><code>HTMLVideoElement.disablePictureInPicture</code></h3>

<div class="hidden">The compatibility table on this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</div>

<p>{{Compat("api.HTMLVideoElement.disablePictureInPicture")}}</p>

<h3 id="Document.pictureInPictureEnabled"><code>Document.pictureInPictureEnabled</code></h3>

<div class="hidden">The compatibility table on this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</div>

<p>{{Compat("api.Document.pictureInPictureEnabled")}}</p>

<h3 id="Document.exitPictureInPicture"><code>Document.exitPictureInPicture</code></h3>

<div class="hidden">The compatibility table on this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</div>

<p>{{Compat("api.Document.exitPictureInPicture")}}</p>

<h3 id="DocumentOrShadowRoot.pictureInPictureElement"><code>DocumentOrShadowRoot.pictureInPictureElement</code></h3>

<div class="hidden">The compatibility table on this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</div>

<p>{{Compat("api.DocumentOrShadowRoot.pictureInPictureElement")}}</p>

<h3 id="PictureInPictureWindow"><code>PictureInPictureWindow</code></h3>

<div class="hidden">The compatibility table on this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</div>

<p>{{Compat("api.PictureInPictureWindow")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{DOMxRef("HTMLVideoElement.requestPictureInPicture()")}}</li>
 <li>{{DOMxRef("HTMLVideoElement.autoPictureInPicture")}}</li>
 <li>{{DOMxRef("HTMLVideoElement.disablePictureInPicture")}}</li>
 <li>{{DOMxRef("Document.pictureInPictureEnabled")}}</li>
 <li>{{DOMxRef("Document.exitPictureInPicture()")}}</li>
 <li>{{DOMxRef("DocumentOrShadowRoot.pictureInPictureElement")}}</li>
 <li>{{CSSxRef(":picture-in-picture")}}</li>
</ul>
